function Dice_Load()
	success_01 = RegisterAddonMessagePrefix("LD_DICING");
	
	if (success_01 == true) then
		print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFFLoaded. \124cFFFFFF00Thank you for installing Ulsting's Liar's Dice!");
		print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFFType \124cFFFFFF00/ld help\124cFFFFFFFF for instructions.");
	else
		print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFFCould not load. You have too many addons conflicting.");
		return;
	end
	
	LD_PLAYER_NAME = UnitName("player");
	inGame = false;
	gameMaster = false;
	waitingForBid = false;
	yourBid = false;
	LD_MSG_PREFIX = "LD_DICING";
	lastDice = "";
	gameCode = "";
	roundCode = 0;
	diceInPlay = 0;
	playersInGame = {};
	originalPlayersInGame = {};
	numberOfPlayersLeftInGame = 0;
	dicePerPlayer = 0;
	previousBidder = "";
	previousBid = "";
	previousBidToMe = "";
	currentBidder = "";
	diceValuesThisRound = {};
	BidderNumber = 0;
	myTurnToBid = true;
	myBidderNumber = 0;
	waitingForResultsFromGamesWithGameCodes = {};
	bidderInRound = 0;
	BID_TIMEOUT_SECONDS = 60;
	myTimerIteration = 0;
	diceToSubtract = 0;
	myCurrentColorIndex = 1;
	startingRoundPlayer = 0;
	myColorTable = {"\124cFFFF9900[Liar's Dice]\124cFFFFFFFF ", "\124cFFFF0000[Liar's Dice]\124cFFFFFFFF ", "\124cFFFFFF00[Liar's Dice]\124cFFFFFFFF ", "\124cFF00B4FF[Liar's Dice]\124cFFFFFFFF ", "\124cFFCC00FF[Liar's Dice]\124cFFFFFFFF "};
	bidSoundFiles = {"Bid", "BiddingTime", "PleaseJustFuckingBidAlready", "ShutTheFuckUpAndBid", "YourTimeHasComeBidNow", "YourTimeHasComeBidNowSong1", "YourTimeHasComeBidNowSong2"};
	soundFilesBasePath = "Interface\\AddOns\\LiarsDice\\Sounds\\";
	loadedOnce = false;
 end
SLASH_LIARSDICE1 = '/ld';

function printMessage(msg)
	if myCurrentColorIndex > 5 then
		myCurrentColorIndex = 1;
	end
	print(myColorTable[myCurrentColorIndex]..msg);
end

local function handler(msg, editbox)
	myCurrentColorIndex = myCurrentColorIndex + 1;
	local command, arg1, arg2, arg3, arg4 = strsplit(" ",msg)
	
	if command == "bid" then
		if myTurnToBid then --my turn to bid
			if arg1 == "liar" then --valid bid command of liar
				if myBidderNumber > 1 then
					waitingForBid = false;
					myTurnToBid = false;
					printMessage("Bid accepted.");
					SendAddonMessage(LD_MSG_PREFIX,"BIDLIAR".."$"..gameCode, "RAID");
				else
					printMessage("Since you are the first bidder this round, you may not make a bid of liar.");
				end
			elseif arg1 ~= nil and arg2 ~= nil then --valid regular bid command
				local pBidAmount, pBidValue = strsplit(" ", previousBidToMe);
				if tonumber(arg1) < 1 then
					printMessage("Invalid bid. You must bid \124cFFFFFF00AT LEAST\124cFFFFFFFF one die.");
				elseif tonumber(arg1) > diceInPlay then --there aren't that many dice in play!
					printMessage("Invalid bid. There are only \124cFFFFFF00"..diceInPlay.."\124cFFFFFFFF dice in play.");
				elseif tonumber(arg2) > 6 then --dice can't have more than 6 sides
					printMessage("Invalid bid. Dice values can \124cFFFFFF00NOT exceed 6\124cFFFFFFFF.");
				elseif tonumber(pBidAmount) == diceInPlay and tonumber(pBidValue) == 6 then --previous bid was highest bid possible
					printMessage("The previous bidder made the highest bid possible. Therefore you may only make a bid of liar. May the odds be in your favor, good luck!");
				else
					local oneGreater = nil;
					if pBidAmount ~= nil and pBidValue ~= nil then
						oneGreater = false;
						if tonumber(arg1) > tonumber(pBidAmount) then --check to make sure bid is higher and/or equal to previous bid
							oneGreater = true;
						elseif tonumber(arg2) > tonumber(pBidValue) then
							oneGreater = true;
						end
					end
					
					if oneGreater or oneGreater == nil then
						waitingForBid = false;
						myTurnToBid = false;
						printMessage("Bid accepted.");
						SendAddonMessage(LD_MSG_PREFIX,"BIDREGULAR".."$"..gameCode.."$"..arg1.."+"..arg2, "RAID");
					else --invalid bid, one of the values must be greater than the previos bidder's bid
						printMessage("Invalid bid. \124cFFFFFF00At least\124cFFFFFFFF one of your bid numbers must be higher than the previous bidder's bid.");
					end
				end
			else --invalid bid command, niether liar nor regular bid
				printMessage("Invalid bid command. Type \124cFFFFFF00/ld help\124cFFFFFFFF for help.");
			end
		else --not my turn to bid
			printMessage("It is not your turn to bid yet, please wait.");
		end
	elseif command == "show" and arg1 == "roll" then
		if lastDice ~= "" then
			printMessage("You rolled \124cFFFFFF00"..lastDice.."\124cFFFFFFFF this turn.");
		else
			printMessage("You have no roll to show!");
		end
	elseif command == "help" then --valid help command
		printMessage("Type \124cFFFFFF00/ld create game gameCode dicePerPlayer bidTimeOut\124cFFFFFFFF to create a new game. The value \124cFFFFFF00gameCode\124cFFFFFFFF will be the code for your game and may \124cFFFFFF00NOT\124cFFFFFFFF contain spaces. The value \124cFFFFFF00dicerPerPlayer\124cFFFFFFFF is how many dice each player will start with. The value \124cFFFFFF00bidTimeOut\124cFFFFFFFF is the number of seconds that a player is given to bid before they are skipped over and lose a die, this value \124cFFFFFF00defaults to 60 seconds\124cFFFFFFFF if omitted.");
		printMessage("Type \124cFFFFFF00/ld stop game \124cFFFFFFFFto stop the current game your are the game master of. \124cFFFFFF00WARNING!\124cFFFFFFFF This will end your current game.");
		printMessage("ype \124cFFFFFF00/ld start game \124cFFFFFFFFto start your game. After this, no one new will be able to join your game.");
		printMessage("Type \124cFFFFFF00/ld join gameCode \124cFFFFFFFFto join a game. The value \124cFFFFFF00gameCode\124cFFFFFFFF will be the code printed out when someone starts a game, you must copy it \124cFFFFFF00EXACTLY\124cFFFFFFFF.");
		printMessage("Type \124cFFFFFF00/ld bid X Y \124cFFFFFFFFor\124cFFFFFF00 /ld bid liar\124cFFFFFFFF. \124cFFFFFF00X\124cFFFFFFFF is the number of dice, and \124cFFFFFF00Y\124cFFFFFFFF is the value of the dice. \124cFFFFFF00Liar\124cFFFFFFFF will call the person who went before you a liar!");
		printMessage("Type \124cFFFFFF00/ld show roll \124cFFFFFFFFto print out your roll for the current round. \124cFFFFFF00Only you\124cFFFFFFFF will be able to see this.");
	elseif command == "join" then --valid join game command
		if arg1 ~= nil then --valid join game command with a game code
			SendAddonMessage(LD_MSG_PREFIX,"JOINGAMEREQUEST".."$"..arg1.."$".."", "RAID");
		else --invalid join game command, no game code
			printMessage("You must enter the game code of the game you wish to join. Type \124cFFFFFF00/ld help\124cFFFFFFFF for help.");
		end
	elseif command == "create" and arg1 == "game" then
		if arg2 ~= nil and arg3 ~= nil then --valid new game command with a game code
			if gameCode == "" then --no game exists, create game
				if tonumber(arg3) then --dice amount is valid
					if tonumber(arg4) ~= nil then
						BID_TIMEOUT_SECONDS = tonumber(arg4);
						if BID_TIMEOUT_SECONDS == nil then
							printMessage("The number of seconds for a player to bid may \124cFFFFFF00ONLY\124cFFFFFFFF contain \124cFFFFFF00numbers\124cFFFFFFFF.");
							return;
						end
					end
					gameCode = arg2;
					waitingForResultsFromGamesWithGameCodes[gameCode] = 1;
					roundCode = 0;
					diceInPlay = 0;
					dicePerPlayer = arg3;
					inGame = true;
					gameMaster = true;
					BidderNumber = 0;
					
					previousBidder = "";
					currentBidder = "";
					previousBid = "";
					diceValuesThisRound = {};
					myTurnToBid = false;
					myBidderNumber = 0;
					previousBidToMe = "";
					bidderInRound = 0;
					myTimerIteration = 0;
					diceToSubtract = 0;
					startingRoundPlayer = 0;
					
					playersInGame[LD_PLAYER_NAME] = dicePerPlayer;
					numberOfPlayersLeftInGame = 1;
					diceInPlay = diceInPlay + dicePerPlayer;
					
					SendAddonMessage(LD_MSG_PREFIX,"NEWGAME".."$"..gameCode.."$".."", "RAID");
					printMessage("Creating new game with game code \124cFFFFFF00"..gameCode.."\124cFFFFFFFF.");
				else --dice amount was invalid
					printMessage("Amount of dice per player must be a number. Type \124cFFFFFF00/ld help\124cFFFFFFFF for help.");
				end
			else --a game already exists, do nothing
				printMessage("You are already in a game with game code \124cFFFFFF00"..gameCode.."\124cFFFFFFFF!");
			end
		elseif arg1 ~= nil then --valid new game, game code was given but no dice amount
			printMessage("You must enter a dice amount when starting a new game. Type \124cFFFFFF00/ld help\124cFFFFFFFF for help.");
		else --valid new game, but no game code was given
			printMessage("You must enter a game code and dice amount when starting a new game. Type \124cFFFFFF00/ld help\124cFFFFFFFF for help.");
		end
	elseif command == "stop" and arg1 == "game" then --valid stop game command
		if gameCode ~= nil then --currently in a game
			roundCode = 0;
			playersInGame = {};
			lastDice = "";
			inGame = false;
			gameMaster = false;
			myTurnToBid = false;
			waitingForBid = false;

			SendAddonMessage(LD_MSG_PREFIX,"GAMEOVER".."$"..gameCode.."$".."nil", "RAID");
			printMessage("You stoppped the game with gameCode '\124cFFFFFF00"..gameCode.."\124cFFFFFFFF'.");
			gameCode = "";
		else --not currently in a game
			printMessage("You must be in a game in order to stop a game first, silly.");
		end
	elseif command == "start" and arg1 == "game" then --valid start game command
		if (not inGame) then --no game to start!
			printMessage("You must be in a game and be the game master in order the start a game.");
		else --starting game!
			startRound();
		end
	else --invalid command
		printMessage("Invalid command. Type \124cFFFFFF00/ld help\124cFFFFFFFF for help.");
	end
	myCurrentColorIndex = myCurrentColorIndex + 1;
end
SlashCmdList["LIARSDICE"] = handler;

function rollDice(msg)
	local stringRoll = "You rolled: \124cFFFFFF00";
	local stringDice = "";
	local SIDES_PER_DIE = 6;
	
	for i = 1, msg do
		stringDice = stringDice .. " " .. math.random(SIDES_PER_DIE);
		i = i + 1;
	end
	SaveDice(stringDice);
	myCurrentColorIndex = myCurrentColorIndex + 1;
	printMessage(stringRoll .. stringDice);
end

function SaveDice(stringDice)
	lastDice = stringDice;	
end

function startRound()
	if inGame then
		roundCode = roundCode + 1;
		previousBidder = "";
		currentBidder = "";
		previousBid = "";
		bidderInRound = 0;
		diceInPlay = diceInPlay - diceToSubtract;
		diceToSubtract = 0;
		
		diceValuesThisRound = {};
		diceValuesThisRound["1"] = 0;
		diceValuesThisRound["2"] = 0;
		diceValuesThisRound["3"] = 0;
		diceValuesThisRound["4"] = 0;
		diceValuesThisRound["5"] = 0;
		
		for key, val in pairs(playersInGame) do --issue roll commands to each player with their number of remaining dice
			if tonumber(playersInGame[key]) > 0 then
				SendAddonMessage(LD_MSG_PREFIX,"NEWROUND".."$"..gameCode.."$"..roundCode.."+"..key.."+"..playersInGame[key], "RAID");
			end
		end
		
		
		if startingRoundPlayer ~= getTableLength(playersInGame) then
			startingRoundPlayer = startingRoundPlayer + 1;
		elseif startingRoundPlayer > getTableLength(playersInGame) then
			startingRoundPlayer = 1;
		end
		
		local name = getNameAtIndexInTable(startingRoundPlayer);
		requestBid(name);
		
		if startingRoundPlayer == getTableLength(playersInGame) then
			startingRoundPlayer = 0;
		end
	end
end

function getTableLength(tab)
	local jindex = 0;
	for key, val in pairs(tab) do
		jindex = jindex + 1;
	end
	return jindex;
end

function requestBid(CurrentBidder)
	local playerToBid = getNextBidder(CurrentBidder);
	local playerToBidsDice = playersInGame[playerToBid];
	if playerToBidsDice == 0 then
		playersInGame[playerToBid] = nil;
		SendAddonMessage(LD_MSG_PREFIX,"LOSTGAME".."$"..gameCode.."$"..playerToBid, "RAID");
		table.remove(playersInGame, playerIndex);
		numberOfPlayersLeftInGame = numberOfPlayersLeftInGame - 1;
		if (numberOfPlayersLeftInGame == 1) then
			inGame = false;
			SendAddonMessage(LD_MSG_PREFIX,"GAMEOVER".."$"..gameCode.."$"..getNameAtIndexInTable(1), "RAID");
			return;
		end
		requestBid(CurrentBidder);
	else
		bidderInRound = bidderInRound + 1;
		BidderNumber = BidderNumber + 1;
		SendAddonMessage(LD_MSG_PREFIX,"REQUESTBID".."$"..gameCode.."$"..playerToBid.."+"..BidderNumber.."+"..diceInPlay.."+"..previousBidder.."+"..previousBid.."+"..bidderInRound.."+"..BID_TIMEOUT_SECONDS, "RAID");
	end
end

function getNextBidder(CurrentBidder)
	if CurrentBidder ~= nil then
		local foundNext = false;
		for key, val in pairs(playersInGame) do
			if foundNext then
				return key;
			end
			
			if key == CurrentBidder then
				foundNext = true;
			end
		end
	end
	local newBidder = getNameAtIndexInTable(1);
	return newBidder;
end

function getNameAtIndexInTable(index)
	local jindex = 1;
	for key, val in pairs(playersInGame) do
		if jindex == index then
			return key;
		else
			jindex = jindex + 1;
		end
	end
end

function startBidTimer()
	if myTimerIteration*5 > BID_TIMEOUT_SECONDS then
		myTimerIteration = 0;
		bidderTimeout();
	else
		if waitingForBid then
			myTimerIteration = myTimerIteration + 1;
			C_Timer.After(5, startBidTimer);
		elseif myTimerIteration > 0 then
			myTimerIteration = 0;
		end
	end
end

function bidderTimeout()
	waitingForBid = false;
	myTurnToBid = false;
	SendAddonMessage(LD_MSG_PREFIX,"BIDTIMEOUT".."$"..gameCode.."$"..myBidderNumber, "RAID");
	myCurrentColorIndex = myCurrentColorIndex + 1;
	printMessage("You have failed to bid in time and have \124cFFFF0000lost 1 die\124cFFFFFFFF as a result.");
end

if not ReceiveDiceFrame then
   ReceiveDiceFrame = CreateFrame("Frame")
end

local function OnEvent(self, event, prefix, message, channel, sender)
	if prefix == "LD_DICING" then
		local sendingPlayerName, sendingPlayerRealm = strsplit("-", sender);
		local prefix, gameToken, msg = strsplit("$", message);
		
		if prefix == "GAMEOVER" then
			if gameCode == gameToken then
				gameCode = "";
				inGame = false; --not sure which of these are necessary, just covering all the bases at this point
				yourBid = false;
				lastDice = "";
				gameCode = "";
				roundCode = 0;
				diceInPlay = 0;
				myBidderNumber = 0;
				previousBidder = "";
				previousBid = "";
				currentBidder = "";
				timesIHaveBid = 0;
				myTurnToBid = false;
				myBidderNumber = 0;
				waitingForBid = false;
				previousBidToMe = "";
				bidderInRound = 0;
				myTimerIteration = 0;
				diceToSubtract = 0;
			end
			
			if waitingForResultsFromGamesWithGameCodes[gameToken] ~= nil then
				waitingForResultsFromGamesWithGameCodes[gameToken] = nil;
				if msg ~= "nil" then --there was a winner
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("\124cFFFFFF00"..sendingPlayerName.."'s\124cFFFFFFFF game with game code \124cFFFFFF00"..gameToken.."\124cFFFFFFFF has ended. \124cFFFFFF00"..msg.." \124cFFFFFFFFwon!");
				else --there was no winner
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("\124cFFFFFF00"..sendingPlayerName.."'s\124cFFFFFFFF game with game code \124cFFFFFF00"..gameToken.."\124cFFFFFFFF has ended. There was no winner.");
				end
			end
		end
		
		if not inGame then
			if prefix == "NEWGAME" then
				myCurrentColorIndex = myCurrentColorIndex + 1;
				printMessage("\124cFFFFFF00"..sendingPlayerName.."\124cFFFFFFFF started a new game with game code \124cFFFFFF00"..gameToken.."\124cFFFFFFFF. Type \124cFFFFFF00/ld join gameCode\124cFFFFFFFF to join. But be quick! You must join before they start the game.\124cFFFFFF00");
			elseif LD_PLAYER_NAME == msg then
				if prefix == "JOINSUCCESS" then
					inGame = true;
					waitingForResultsFromGamesWithGameCodes[gameToken] = 1;
					gameCode = gameToken;
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("You successfully joined \124cFFFFFF00"..sendingPlayerName.."'s \124cFFFFFFFF game!");
				elseif prefix == "INVALIDTOKEN" then
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("The token you gave to join a game was invalid. Please try again.");
				elseif prefix == "JOINLATE" then
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("You are too late in joining \124cFFFFFF00"..sendingPlayerName.."'s \124cFFFFFFFF game! Be faster next time slick!");
				end
			end
		end
		
		if inGame and not gameMaster then
			if LD_PLAYER_NAME == msg then
				if prefix == "JOINREDUNDANT" then
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("You are already in \124cFFFFFF00"..sendingPlayerName.."'s \124cFFFFFFFF game!");
				end
			end
		end
		
		if gameMaster then
			if prefix == "JOINGAMEREQUEST" then
				if roundCode == 0 then --game has not started yet
					if gameToken ~= gameCode then --invalid game code was given
						SendAddonMessage(LD_MSG_PREFIX,"INVALIDTOKEN".."$"..gameCode.."$"..sendingPlayerName, "RAID");
					elseif playersInGame[sendingPlayerName] == nil then --player is not in game yet
						playersInGame[sendingPlayerName] = dicePerPlayer;
						numberOfPlayersLeftInGame = numberOfPlayersLeftInGame + 1;
						diceInPlay = diceInPlay + dicePerPlayer;
						
						SendAddonMessage(LD_MSG_PREFIX,"JOINSUCCESS".."$"..gameCode.."$"..sendingPlayerName, "RAID");
						myCurrentColorIndex = myCurrentColorIndex + 1;
						printMessage("\124cFFFFFF00"..sendingPlayerName.."\124cFFFFFFFF has joined your game!");
					else --player is already in game
						SendAddonMessage(LD_MSG_PREFIX,"JOINREDUNDANT".."$"..gameCode.."$"..sendingPlayerName, "RAID");
					end
				else --game has started and is no longer joinable
					SendAddonMessage(LD_MSG_PREFIX,"JOINLATE".."$"..gameCode.."$"..sendingPlayerName, "RAID");
				end
			end
			
			if roundCode > 0 then
				if prefix == "DICEROLLED" then
					local _, d1, d2, d3, d4, d5 = strsplit(" ", msg);
					if d1 ~= nil then
						if diceValuesThisRound[d1] ~= nil then
							diceValuesThisRound[d1] = diceValuesThisRound[d1] + 1;
						else
							diceValuesThisRound[d1] = 1;
						end
					end
					if d2 ~= nil then
						if diceValuesThisRound[d2] ~= nil then
							diceValuesThisRound[d2] = diceValuesThisRound[d2] + 1;
						else
							diceValuesThisRound[d2] = 1;
						end
					end
					if d3 ~= nil then
						if diceValuesThisRound[d3] ~= nil then
							diceValuesThisRound[d3] = diceValuesThisRound[d3] + 1;
						else
							diceValuesThisRound[d3] = 1;
						end
					end
					if d4 ~= nil then
						if diceValuesThisRound[d4] ~= nil then
							diceValuesThisRound[d4] = diceValuesThisRound[d4] + 1;
						else
							diceValuesThisRound[d4] = 1;
						end
					end
					if d5 ~= nil then
						if diceValuesThisRound[d5] ~= nil then
							diceValuesThisRound[d5] = diceValuesThisRound[d5] + 1;
						else
							diceValuesThisRound[d5] = 1;
						end
					end
				elseif prefix == "BIDREGULAR" then
					previousBidder = sendingPlayerName;
					local previousBidP1, previousBidP2 = strsplit("+", msg);
					previousBid = previousBidP1.." "..previousBidP2;
					requestBid(sendingPlayerName);
				elseif prefix == "BIDLIAR" then
					local activeBidP1, activeBidP2 = strsplit(" ", previousBid);
					if diceValuesThisRound[activeBidP2] < tonumber(activeBidP1) then --the person who made a bid was lying! they lose a die!
						playersInGame[previousBidder] = playersInGame[previousBidder] - 1;
						SendAddonMessage(LD_MSG_PREFIX,"BIDLIARRECIPIENT".."$"..gameCode.."$"..previousBidder.."+".."t", "RAID");
						SendAddonMessage(LD_MSG_PREFIX,"BIDLIARACCUSER".."$"..gameCode.."$"..sendingPlayerName.."+".."t", "RAID");
					else --the person who made a bid was telling the truth!
						playersInGame[sendingPlayerName] = playersInGame[sendingPlayerName] - 1;
						SendAddonMessage(LD_MSG_PREFIX,"BIDLIARRECIPIENT".."$"..gameCode.."$"..previousBidder.."+".."f", "RAID");
						SendAddonMessage(LD_MSG_PREFIX,"BIDLIARACCUSER".."$"..gameCode.."$"..sendingPlayerName.."+".."f", "RAID");
					end
					diceInPlay = diceInPlay - 1;
					startRound();
				elseif prefix == "BIDTIMEOUT" then
					local timeoutBidderNumber = tonumber(msg);
					playersInGame[sendingPlayerName] = playersInGame[sendingPlayerName] - 1;
					diceToSubtract = diceToSubtract + 1;
					requestBid(sendingPlayerName);
				end
			end
		end
		
		if inGame then
			if prefix == "REQUESTBID" then
				local playerToBid, bidderNumber, DiceInPlay, previousBidder, prevBid, BidderInRound, bidTimeoutSeconds = strsplit("+", msg);
				if LD_PLAYER_NAME == playerToBid then
					BID_TIMEOUT_SECONDS = tonumber(bidTimeoutSeconds);
					bidderInRound = BidderInRound;
					diceInPlay = tonumber(DiceInPlay);
					myTurnToBid = true;
					myBidderNumber = tonumber(bidderNumber);
					previousBidToMe = prevBid;
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("It is your turn to bid! You have\124cFFFFFF00 "..BID_TIMEOUT_SECONDS.." seconds\124cFFFFFFFF to bid or you will \124cFFFF0000lose a die\124cFFFFFFFF and be skipped over this round."); 
					printMessage("You are bidder number \124cFFFFFF00"..bidderInRound.."\124cFFFFFFFF. There are \124cFFFF0000"..DiceInPlay.." dice\124cFFFFFFFF in play this round.");
					if tonumber(bidderNumber) > 1 and previousBidder ~= "" and prevBid ~= "" then
						printMessage("The previous bidder \124cFFFFFF00"..previousBidder.."\124cFFFFFFFF bid \124cFFFFFF00"..prevBid.."\124cFFFFFFFF.");
					end
					waitingForBid = true;
					myTimerIteration = 0;
					startBidTimer();
				end
			elseif prefix == "NEWROUND" then
				local RoundCode , playerName, myDice = strsplit("+", msg);
				if LD_PLAYER_NAME == playerName then
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("Round number \124cFFFFFF00"..RoundCode.." \124cFFFFFFFFhas started!");
					rollDice(myDice);
					SendAddonMessage(LD_MSG_PREFIX,"DICEROLLED".."$"..gameCode.."$"..lastDice, "RAID");
					myBidderNumber = 0;
				end
			elseif prefix == "BIDLIARACCUSER" then
				local msgAdressee, outcome = strsplit("+", msg);
				if LD_PLAYER_NAME == msgAdressee then
					if outcome == "f" then --you lost!
						myCurrentColorIndex = myCurrentColorIndex + 1;
						printMessage("No liars here. You \124cFFFFFF00lose 1 die\124cFFFFFFFF!");
					else --you won!
						myCurrentColorIndex = myCurrentColorIndex + 1;
						printMessage("Hurray! Liar detected, nice call!");
					end
				end
			elseif prefix == "BIDLIARRECIPIENT" then
				local msgAdressee, outcome = strsplit("+", msg);
				if LD_PLAYER_NAME == msgAdressee then
					if outcome == "f" then --you won!
						myCurrentColorIndex = myCurrentColorIndex + 1;
						printMessage("You were called out as a liar, but the dice were in your favor!");
					else --you lost!
						myCurrentColorIndex = myCurrentColorIndex + 1;
						printMessage("You got caught lying and have \124cFFFFFF00lost 1 die\124cFFFFFFFF as a result.");
					end
				end
			elseif prefix == "LOSTGAME" then
				if LD_PLAYER_NAME == msg then
					if not gameMaster then
						inGame = false; --not sure which of these are necessary, just covering all the bases at this point
						yourBid = false;
						lastDice = "";
						gameCode = "";
						roundCode = 0;
						diceInPlay = 0;
						myBidderNumber = 0;
						previousBidder = "";
						previousBid = "";
						currentBidder = "";
						timesIHaveBid = 0;
						myTurnToBid = false;
						myBidderNumber = 0;
						waitingForBid = false;
						previousBidToMe = "";
						bidderInRound = 0;
						myTimerIteration = 0;
					end
					
					myCurrentColorIndex = myCurrentColorIndex + 1;
					printMessage("Sorry mate, but you have lost the game with game code \124cFFFFFF00"..gameToken.."\124cFFFFFFFF. You will be notified who the winner is or when the game is over, whichever comes first!");
					printMessage("For now you're free to join another. Thanks for playing =)");
				end
			end
		end
	end
end

local frame = ReceiveDiceFrame;
frame:RegisterEvent("CHAT_MSG_ADDON");
frame:SetScript("OnEvent", OnEvent);